// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/AdviceResponse.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ADVICE_RESPONSE__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ADVICE_RESPONSE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'maneuver_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_id__struct.hpp"
// Member 'advice_update_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/advice_update_id__struct.hpp"
// Member 'advice_followed'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_response__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__AdviceResponse __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__AdviceResponse __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AdviceResponse_
{
  using Type = AdviceResponse_<ContainerAllocator>;

  explicit AdviceResponse_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : maneuver_id(_init),
    advice_update_id(_init),
    advice_followed(_init)
  {
    (void)_init;
  }

  explicit AdviceResponse_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : maneuver_id(_alloc, _init),
    advice_update_id(_alloc, _init),
    advice_followed(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _maneuver_id_type =
    etsi_its_mcm_uulm_msgs::msg::ManeuverID_<ContainerAllocator>;
  _maneuver_id_type maneuver_id;
  using _advice_update_id_type =
    etsi_its_mcm_uulm_msgs::msg::AdviceUpdateID_<ContainerAllocator>;
  _advice_update_id_type advice_update_id;
  using _advice_followed_type =
    etsi_its_mcm_uulm_msgs::msg::ManeuverResponse_<ContainerAllocator>;
  _advice_followed_type advice_followed;

  // setters for named parameter idiom
  Type & set__maneuver_id(
    const etsi_its_mcm_uulm_msgs::msg::ManeuverID_<ContainerAllocator> & _arg)
  {
    this->maneuver_id = _arg;
    return *this;
  }
  Type & set__advice_update_id(
    const etsi_its_mcm_uulm_msgs::msg::AdviceUpdateID_<ContainerAllocator> & _arg)
  {
    this->advice_update_id = _arg;
    return *this;
  }
  Type & set__advice_followed(
    const etsi_its_mcm_uulm_msgs::msg::ManeuverResponse_<ContainerAllocator> & _arg)
  {
    this->advice_followed = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__AdviceResponse
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__AdviceResponse
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AdviceResponse_ & other) const
  {
    if (this->maneuver_id != other.maneuver_id) {
      return false;
    }
    if (this->advice_update_id != other.advice_update_id) {
      return false;
    }
    if (this->advice_followed != other.advice_followed) {
      return false;
    }
    return true;
  }
  bool operator!=(const AdviceResponse_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AdviceResponse_

// alias to use template instance with default allocator
using AdviceResponse =
  etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ADVICE_RESPONSE__STRUCT_HPP_
