// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/LongitudinalWaypoint.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'waypoint'
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint__struct.hpp"
// Member 'min_arrival_time'
// Member 'max_arrival_time'
// Member 'min_duration_of_stop'
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint_delta_time__struct.hpp"
// Member 'min_velocity'
// Member 'max_velocity'
#include "etsi_its_mcm_uulm_msgs/msg/detail/speed_value__struct.hpp"
// Member 'preceding_road_user'
// Member 'following_road_user'
#include "etsi_its_mcm_uulm_msgs/msg/detail/participating_road_user_index__struct.hpp"
// Member 'yield_to_road_user_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/yield_to_road_user_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LongitudinalWaypoint_
{
  using Type = LongitudinalWaypoint_<ContainerAllocator>;

  explicit LongitudinalWaypoint_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : waypoint(_init),
    min_arrival_time(_init),
    max_arrival_time(_init),
    min_velocity(_init),
    max_velocity(_init),
    min_duration_of_stop(_init),
    preceding_road_user(_init),
    following_road_user(_init),
    yield_to_road_user_container(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->min_velocity_is_present = false;
      this->max_velocity_is_present = false;
      this->min_duration_of_stop_is_present = false;
      this->preceding_road_user_is_present = false;
      this->following_road_user_is_present = false;
      this->yield_to_road_user_container_is_present = false;
    }
  }

  explicit LongitudinalWaypoint_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : waypoint(_alloc, _init),
    min_arrival_time(_alloc, _init),
    max_arrival_time(_alloc, _init),
    min_velocity(_alloc, _init),
    max_velocity(_alloc, _init),
    min_duration_of_stop(_alloc, _init),
    preceding_road_user(_alloc, _init),
    following_road_user(_alloc, _init),
    yield_to_road_user_container(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->min_velocity_is_present = false;
      this->max_velocity_is_present = false;
      this->min_duration_of_stop_is_present = false;
      this->preceding_road_user_is_present = false;
      this->following_road_user_is_present = false;
      this->yield_to_road_user_container_is_present = false;
    }
  }

  // field types and members
  using _waypoint_type =
    etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator>;
  _waypoint_type waypoint;
  using _min_arrival_time_type =
    etsi_its_mcm_uulm_msgs::msg::WaypointDeltaTime_<ContainerAllocator>;
  _min_arrival_time_type min_arrival_time;
  using _max_arrival_time_type =
    etsi_its_mcm_uulm_msgs::msg::WaypointDeltaTime_<ContainerAllocator>;
  _max_arrival_time_type max_arrival_time;
  using _min_velocity_type =
    etsi_its_mcm_uulm_msgs::msg::SpeedValue_<ContainerAllocator>;
  _min_velocity_type min_velocity;
  using _min_velocity_is_present_type =
    bool;
  _min_velocity_is_present_type min_velocity_is_present;
  using _max_velocity_type =
    etsi_its_mcm_uulm_msgs::msg::SpeedValue_<ContainerAllocator>;
  _max_velocity_type max_velocity;
  using _max_velocity_is_present_type =
    bool;
  _max_velocity_is_present_type max_velocity_is_present;
  using _min_duration_of_stop_type =
    etsi_its_mcm_uulm_msgs::msg::WaypointDeltaTime_<ContainerAllocator>;
  _min_duration_of_stop_type min_duration_of_stop;
  using _min_duration_of_stop_is_present_type =
    bool;
  _min_duration_of_stop_is_present_type min_duration_of_stop_is_present;
  using _preceding_road_user_type =
    etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIndex_<ContainerAllocator>;
  _preceding_road_user_type preceding_road_user;
  using _preceding_road_user_is_present_type =
    bool;
  _preceding_road_user_is_present_type preceding_road_user_is_present;
  using _following_road_user_type =
    etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIndex_<ContainerAllocator>;
  _following_road_user_type following_road_user;
  using _following_road_user_is_present_type =
    bool;
  _following_road_user_is_present_type following_road_user_is_present;
  using _yield_to_road_user_container_type =
    etsi_its_mcm_uulm_msgs::msg::YieldToRoadUserContainer_<ContainerAllocator>;
  _yield_to_road_user_container_type yield_to_road_user_container;
  using _yield_to_road_user_container_is_present_type =
    bool;
  _yield_to_road_user_container_is_present_type yield_to_road_user_container_is_present;

  // setters for named parameter idiom
  Type & set__waypoint(
    const etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator> & _arg)
  {
    this->waypoint = _arg;
    return *this;
  }
  Type & set__min_arrival_time(
    const etsi_its_mcm_uulm_msgs::msg::WaypointDeltaTime_<ContainerAllocator> & _arg)
  {
    this->min_arrival_time = _arg;
    return *this;
  }
  Type & set__max_arrival_time(
    const etsi_its_mcm_uulm_msgs::msg::WaypointDeltaTime_<ContainerAllocator> & _arg)
  {
    this->max_arrival_time = _arg;
    return *this;
  }
  Type & set__min_velocity(
    const etsi_its_mcm_uulm_msgs::msg::SpeedValue_<ContainerAllocator> & _arg)
  {
    this->min_velocity = _arg;
    return *this;
  }
  Type & set__min_velocity_is_present(
    const bool & _arg)
  {
    this->min_velocity_is_present = _arg;
    return *this;
  }
  Type & set__max_velocity(
    const etsi_its_mcm_uulm_msgs::msg::SpeedValue_<ContainerAllocator> & _arg)
  {
    this->max_velocity = _arg;
    return *this;
  }
  Type & set__max_velocity_is_present(
    const bool & _arg)
  {
    this->max_velocity_is_present = _arg;
    return *this;
  }
  Type & set__min_duration_of_stop(
    const etsi_its_mcm_uulm_msgs::msg::WaypointDeltaTime_<ContainerAllocator> & _arg)
  {
    this->min_duration_of_stop = _arg;
    return *this;
  }
  Type & set__min_duration_of_stop_is_present(
    const bool & _arg)
  {
    this->min_duration_of_stop_is_present = _arg;
    return *this;
  }
  Type & set__preceding_road_user(
    const etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIndex_<ContainerAllocator> & _arg)
  {
    this->preceding_road_user = _arg;
    return *this;
  }
  Type & set__preceding_road_user_is_present(
    const bool & _arg)
  {
    this->preceding_road_user_is_present = _arg;
    return *this;
  }
  Type & set__following_road_user(
    const etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIndex_<ContainerAllocator> & _arg)
  {
    this->following_road_user = _arg;
    return *this;
  }
  Type & set__following_road_user_is_present(
    const bool & _arg)
  {
    this->following_road_user_is_present = _arg;
    return *this;
  }
  Type & set__yield_to_road_user_container(
    const etsi_its_mcm_uulm_msgs::msg::YieldToRoadUserContainer_<ContainerAllocator> & _arg)
  {
    this->yield_to_road_user_container = _arg;
    return *this;
  }
  Type & set__yield_to_road_user_container_is_present(
    const bool & _arg)
  {
    this->yield_to_road_user_container_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LongitudinalWaypoint_ & other) const
  {
    if (this->waypoint != other.waypoint) {
      return false;
    }
    if (this->min_arrival_time != other.min_arrival_time) {
      return false;
    }
    if (this->max_arrival_time != other.max_arrival_time) {
      return false;
    }
    if (this->min_velocity != other.min_velocity) {
      return false;
    }
    if (this->min_velocity_is_present != other.min_velocity_is_present) {
      return false;
    }
    if (this->max_velocity != other.max_velocity) {
      return false;
    }
    if (this->max_velocity_is_present != other.max_velocity_is_present) {
      return false;
    }
    if (this->min_duration_of_stop != other.min_duration_of_stop) {
      return false;
    }
    if (this->min_duration_of_stop_is_present != other.min_duration_of_stop_is_present) {
      return false;
    }
    if (this->preceding_road_user != other.preceding_road_user) {
      return false;
    }
    if (this->preceding_road_user_is_present != other.preceding_road_user_is_present) {
      return false;
    }
    if (this->following_road_user != other.following_road_user) {
      return false;
    }
    if (this->following_road_user_is_present != other.following_road_user_is_present) {
      return false;
    }
    if (this->yield_to_road_user_container != other.yield_to_road_user_container) {
      return false;
    }
    if (this->yield_to_road_user_container_is_present != other.yield_to_road_user_container_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const LongitudinalWaypoint_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LongitudinalWaypoint_

// alias to use template instance with default allocator
using LongitudinalWaypoint =
  etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__STRUCT_HPP_
