// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/ManeuverConstraints.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONSTRAINTS__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONSTRAINTS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'maneuver_type'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_type__struct.hpp"
// Member 'longitudinal_maneuver_waypoint_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/longitudinal_maneuver_waypoint_container__struct.hpp"
// Member 'maneuver_corridor'
#include "etsi_its_mcm_uulm_msgs/msg/detail/polygon__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ManeuverConstraints_
{
  using Type = ManeuverConstraints_<ContainerAllocator>;

  explicit ManeuverConstraints_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : maneuver_type(_init),
    longitudinal_maneuver_waypoint_container(_init),
    maneuver_corridor(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->maneuver_type_is_present = false;
      this->maneuver_corridor_is_present = false;
    }
  }

  explicit ManeuverConstraints_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : maneuver_type(_alloc, _init),
    longitudinal_maneuver_waypoint_container(_alloc, _init),
    maneuver_corridor(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->maneuver_type_is_present = false;
      this->maneuver_corridor_is_present = false;
    }
  }

  // field types and members
  using _maneuver_type_type =
    etsi_its_mcm_uulm_msgs::msg::ManeuverType_<ContainerAllocator>;
  _maneuver_type_type maneuver_type;
  using _maneuver_type_is_present_type =
    bool;
  _maneuver_type_is_present_type maneuver_type_is_present;
  using _longitudinal_maneuver_waypoint_container_type =
    etsi_its_mcm_uulm_msgs::msg::LongitudinalManeuverWaypointContainer_<ContainerAllocator>;
  _longitudinal_maneuver_waypoint_container_type longitudinal_maneuver_waypoint_container;
  using _maneuver_corridor_type =
    etsi_its_mcm_uulm_msgs::msg::Polygon_<ContainerAllocator>;
  _maneuver_corridor_type maneuver_corridor;
  using _maneuver_corridor_is_present_type =
    bool;
  _maneuver_corridor_is_present_type maneuver_corridor_is_present;

  // setters for named parameter idiom
  Type & set__maneuver_type(
    const etsi_its_mcm_uulm_msgs::msg::ManeuverType_<ContainerAllocator> & _arg)
  {
    this->maneuver_type = _arg;
    return *this;
  }
  Type & set__maneuver_type_is_present(
    const bool & _arg)
  {
    this->maneuver_type_is_present = _arg;
    return *this;
  }
  Type & set__longitudinal_maneuver_waypoint_container(
    const etsi_its_mcm_uulm_msgs::msg::LongitudinalManeuverWaypointContainer_<ContainerAllocator> & _arg)
  {
    this->longitudinal_maneuver_waypoint_container = _arg;
    return *this;
  }
  Type & set__maneuver_corridor(
    const etsi_its_mcm_uulm_msgs::msg::Polygon_<ContainerAllocator> & _arg)
  {
    this->maneuver_corridor = _arg;
    return *this;
  }
  Type & set__maneuver_corridor_is_present(
    const bool & _arg)
  {
    this->maneuver_corridor_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ManeuverConstraints_ & other) const
  {
    if (this->maneuver_type != other.maneuver_type) {
      return false;
    }
    if (this->maneuver_type_is_present != other.maneuver_type_is_present) {
      return false;
    }
    if (this->longitudinal_maneuver_waypoint_container != other.longitudinal_maneuver_waypoint_container) {
      return false;
    }
    if (this->maneuver_corridor != other.maneuver_corridor) {
      return false;
    }
    if (this->maneuver_corridor_is_present != other.maneuver_corridor_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const ManeuverConstraints_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ManeuverConstraints_

// alias to use template instance with default allocator
using ManeuverConstraints =
  etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONSTRAINTS__STRUCT_HPP_
