// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/ManeuverContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'road_user_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_container__struct.hpp"
// Member 'suggested_maneuver_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/suggested_maneuver_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverContainer __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ManeuverContainer_
{
  using Type = ManeuverContainer_<ContainerAllocator>;

  explicit ManeuverContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_user_container(_init),
    suggested_maneuver_container(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit ManeuverContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_user_container(_alloc, _init),
    suggested_maneuver_container(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _road_user_container_type =
    etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator>;
  _road_user_container_type road_user_container;
  using _suggested_maneuver_container_type =
    etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator>;
  _suggested_maneuver_container_type suggested_maneuver_container;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__road_user_container(
    const etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator> & _arg)
  {
    this->road_user_container = _arg;
    return *this;
  }
  Type & set__suggested_maneuver_container(
    const etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator> & _arg)
  {
    this->suggested_maneuver_container = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_ROAD_USER_CONTAINER =
    0u;
  static constexpr uint8_t CHOICE_SUGGESTED_MANEUVER_CONTAINER =
    1u;

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverContainer
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverContainer
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ManeuverContainer_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->road_user_container != other.road_user_container) {
      return false;
    }
    if (this->suggested_maneuver_container != other.suggested_maneuver_container) {
      return false;
    }
    return true;
  }
  bool operator!=(const ManeuverContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ManeuverContainer_

// alias to use template instance with default allocator
using ManeuverContainer =
  etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ManeuverContainer_<ContainerAllocator>::CHOICE_ROAD_USER_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ManeuverContainer_<ContainerAllocator>::CHOICE_SUGGESTED_MANEUVER_CONTAINER;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONTAINER__STRUCT_HPP_
