// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/RoadUserContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'road_user_state'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_state__struct.hpp"
// Member 'planned_trajectory'
#include "etsi_its_mcm_uulm_msgs/msg/detail/planned_trajectory__struct.hpp"
// Member 'desired_route'
#include "etsi_its_mcm_uulm_msgs/msg/detail/desired_route__struct.hpp"
// Member 'advice_response'
#include "etsi_its_mcm_uulm_msgs/msg/detail/advice_response__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__RoadUserContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__RoadUserContainer __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadUserContainer_
{
  using Type = RoadUserContainer_<ContainerAllocator>;

  explicit RoadUserContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_user_state(_init),
    planned_trajectory(_init),
    desired_route(_init),
    advice_response(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->planned_trajectory_is_present = false;
      this->desired_route_is_present = false;
      this->advice_response_is_present = false;
    }
  }

  explicit RoadUserContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_user_state(_alloc, _init),
    planned_trajectory(_alloc, _init),
    desired_route(_alloc, _init),
    advice_response(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->planned_trajectory_is_present = false;
      this->desired_route_is_present = false;
      this->advice_response_is_present = false;
    }
  }

  // field types and members
  using _road_user_state_type =
    etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator>;
  _road_user_state_type road_user_state;
  using _planned_trajectory_type =
    etsi_its_mcm_uulm_msgs::msg::PlannedTrajectory_<ContainerAllocator>;
  _planned_trajectory_type planned_trajectory;
  using _planned_trajectory_is_present_type =
    bool;
  _planned_trajectory_is_present_type planned_trajectory_is_present;
  using _desired_route_type =
    etsi_its_mcm_uulm_msgs::msg::DesiredRoute_<ContainerAllocator>;
  _desired_route_type desired_route;
  using _desired_route_is_present_type =
    bool;
  _desired_route_is_present_type desired_route_is_present;
  using _advice_response_type =
    etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator>;
  _advice_response_type advice_response;
  using _advice_response_is_present_type =
    bool;
  _advice_response_is_present_type advice_response_is_present;

  // setters for named parameter idiom
  Type & set__road_user_state(
    const etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator> & _arg)
  {
    this->road_user_state = _arg;
    return *this;
  }
  Type & set__planned_trajectory(
    const etsi_its_mcm_uulm_msgs::msg::PlannedTrajectory_<ContainerAllocator> & _arg)
  {
    this->planned_trajectory = _arg;
    return *this;
  }
  Type & set__planned_trajectory_is_present(
    const bool & _arg)
  {
    this->planned_trajectory_is_present = _arg;
    return *this;
  }
  Type & set__desired_route(
    const etsi_its_mcm_uulm_msgs::msg::DesiredRoute_<ContainerAllocator> & _arg)
  {
    this->desired_route = _arg;
    return *this;
  }
  Type & set__desired_route_is_present(
    const bool & _arg)
  {
    this->desired_route_is_present = _arg;
    return *this;
  }
  Type & set__advice_response(
    const etsi_its_mcm_uulm_msgs::msg::AdviceResponse_<ContainerAllocator> & _arg)
  {
    this->advice_response = _arg;
    return *this;
  }
  Type & set__advice_response_is_present(
    const bool & _arg)
  {
    this->advice_response_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__RoadUserContainer
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__RoadUserContainer
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadUserContainer_ & other) const
  {
    if (this->road_user_state != other.road_user_state) {
      return false;
    }
    if (this->planned_trajectory != other.planned_trajectory) {
      return false;
    }
    if (this->planned_trajectory_is_present != other.planned_trajectory_is_present) {
      return false;
    }
    if (this->desired_route != other.desired_route) {
      return false;
    }
    if (this->desired_route_is_present != other.desired_route_is_present) {
      return false;
    }
    if (this->advice_response != other.advice_response) {
      return false;
    }
    if (this->advice_response_is_present != other.advice_response_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadUserContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadUserContainer_

// alias to use template instance with default allocator
using RoadUserContainer =
  etsi_its_mcm_uulm_msgs::msg::RoadUserContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_CONTAINER__STRUCT_HPP_
