// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mcm_uulm_msgs:msg/SuggestedManeuver.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__STRUCT_H_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'maneuver_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_id__struct.h"
// Member 'advice_update_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/advice_update_id__struct.h"
// Member 'participating_road_user_id_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/participating_road_user_id_container__struct.h"
// Member 'confirmation_required_flag'
#include "etsi_its_mcm_uulm_msgs/msg/detail/confirmation_required_flag__struct.h"
// Member 'maneuver_parameters'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_parameters__struct.h"

/// Struct defined in msg/SuggestedManeuver in the package etsi_its_mcm_uulm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
  ///   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
  ///   -t
  ///   mcm_uulm
  ///   -o
  ///   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// SuggestedManeuver ::= SEQUENCE {
  ///  maneuverID                          ManeuverID,
  ///  adviceUpdateID                      AdviceUpdateID,
  ///  participatingRoadUserIDContainer    ParticipatingRoadUserIDContainer,
  ///  confirmationRequiredFlag            ConfirmationRequiredFlag,
  ///  maneuverParameters                  ManeuverParameters
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_mcm_uulm_msgs__msg__ManeuverID maneuver_id;
  etsi_its_mcm_uulm_msgs__msg__AdviceUpdateID advice_update_id;
  etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIDContainer participating_road_user_id_container;
  etsi_its_mcm_uulm_msgs__msg__ConfirmationRequiredFlag confirmation_required_flag;
  etsi_its_mcm_uulm_msgs__msg__ManeuverParameters maneuver_parameters;
} etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver;

// Struct for a sequence of etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver.
typedef struct etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver__Sequence
{
  etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__STRUCT_H_
