// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mcm_uulm_msgs:msg/TerminationStatus.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__TERMINATION_STATUS__STRUCT_H_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__TERMINATION_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'REGULAR_END'.
enum
{
  etsi_its_mcm_uulm_msgs__msg__TerminationStatus__REGULAR_END = 0
};

/// Constant 'ABORT_BY_REJECT'.
enum
{
  etsi_its_mcm_uulm_msgs__msg__TerminationStatus__ABORT_BY_REJECT = 1
};

/// Constant 'ABORT_BY_TIMEOUT'.
enum
{
  etsi_its_mcm_uulm_msgs__msg__TerminationStatus__ABORT_BY_TIMEOUT = 2
};

/// Constant 'ABORT_BY_CONSTRAINT_VIOLATION'.
enum
{
  etsi_its_mcm_uulm_msgs__msg__TerminationStatus__ABORT_BY_CONSTRAINT_VIOLATION = 3
};

/// Constant 'ABORT_BY_EMERGENCY_VEHICLE_APPEARANCE'.
enum
{
  etsi_its_mcm_uulm_msgs__msg__TerminationStatus__ABORT_BY_EMERGENCY_VEHICLE_APPEARANCE = 4
};

/// Constant 'REASON_UNKNOWN'.
enum
{
  etsi_its_mcm_uulm_msgs__msg__TerminationStatus__REASON_UNKNOWN = 15
};

/// Struct defined in msg/TerminationStatus in the package etsi_its_mcm_uulm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mcm_uulm_msgs__msg__TerminationStatus
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
  ///   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
  ///   -t
  ///   mcm_uulm
  ///   -o
  ///   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// TerminationStatus ::= ENUMERATED {
  ///  regularEnd                           (0),
  ///  abortByReject                        (1),
  ///  abortByTimeout                       (2),
  ///  abortByConstraintViolation           (3),
  ///  abortByEmergencyVehicleAppearance    (4),
  ///  reasonUnknown                       (15)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_mcm_uulm_msgs__msg__TerminationStatus;

// Struct for a sequence of etsi_its_mcm_uulm_msgs__msg__TerminationStatus.
typedef struct etsi_its_mcm_uulm_msgs__msg__TerminationStatus__Sequence
{
  etsi_its_mcm_uulm_msgs__msg__TerminationStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mcm_uulm_msgs__msg__TerminationStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__TERMINATION_STATUS__STRUCT_H_
