// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mcm_uulm_msgs:msg/Waypoint.idl
// generated code does not contain a copyright notice
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `x_distance`
// Member `y_distance`
#include "etsi_its_mcm_uulm_msgs/msg/detail/cartesian_coordinate_large__functions.h"

bool
etsi_its_mcm_uulm_msgs__msg__Waypoint__init(etsi_its_mcm_uulm_msgs__msg__Waypoint * msg)
{
  if (!msg) {
    return false;
  }
  // x_distance
  if (!etsi_its_mcm_uulm_msgs__msg__CartesianCoordinateLarge__init(&msg->x_distance)) {
    etsi_its_mcm_uulm_msgs__msg__Waypoint__fini(msg);
    return false;
  }
  // y_distance
  if (!etsi_its_mcm_uulm_msgs__msg__CartesianCoordinateLarge__init(&msg->y_distance)) {
    etsi_its_mcm_uulm_msgs__msg__Waypoint__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__Waypoint__fini(etsi_its_mcm_uulm_msgs__msg__Waypoint * msg)
{
  if (!msg) {
    return;
  }
  // x_distance
  etsi_its_mcm_uulm_msgs__msg__CartesianCoordinateLarge__fini(&msg->x_distance);
  // y_distance
  etsi_its_mcm_uulm_msgs__msg__CartesianCoordinateLarge__fini(&msg->y_distance);
}

bool
etsi_its_mcm_uulm_msgs__msg__Waypoint__are_equal(const etsi_its_mcm_uulm_msgs__msg__Waypoint * lhs, const etsi_its_mcm_uulm_msgs__msg__Waypoint * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // x_distance
  if (!etsi_its_mcm_uulm_msgs__msg__CartesianCoordinateLarge__are_equal(
      &(lhs->x_distance), &(rhs->x_distance)))
  {
    return false;
  }
  // y_distance
  if (!etsi_its_mcm_uulm_msgs__msg__CartesianCoordinateLarge__are_equal(
      &(lhs->y_distance), &(rhs->y_distance)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__Waypoint__copy(
  const etsi_its_mcm_uulm_msgs__msg__Waypoint * input,
  etsi_its_mcm_uulm_msgs__msg__Waypoint * output)
{
  if (!input || !output) {
    return false;
  }
  // x_distance
  if (!etsi_its_mcm_uulm_msgs__msg__CartesianCoordinateLarge__copy(
      &(input->x_distance), &(output->x_distance)))
  {
    return false;
  }
  // y_distance
  if (!etsi_its_mcm_uulm_msgs__msg__CartesianCoordinateLarge__copy(
      &(input->y_distance), &(output->y_distance)))
  {
    return false;
  }
  return true;
}

etsi_its_mcm_uulm_msgs__msg__Waypoint *
etsi_its_mcm_uulm_msgs__msg__Waypoint__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__Waypoint * msg = (etsi_its_mcm_uulm_msgs__msg__Waypoint *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__Waypoint), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mcm_uulm_msgs__msg__Waypoint));
  bool success = etsi_its_mcm_uulm_msgs__msg__Waypoint__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mcm_uulm_msgs__msg__Waypoint__destroy(etsi_its_mcm_uulm_msgs__msg__Waypoint * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mcm_uulm_msgs__msg__Waypoint__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence__init(etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__Waypoint * data = NULL;

  if (size) {
    data = (etsi_its_mcm_uulm_msgs__msg__Waypoint *)allocator.zero_allocate(size, sizeof(etsi_its_mcm_uulm_msgs__msg__Waypoint), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mcm_uulm_msgs__msg__Waypoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mcm_uulm_msgs__msg__Waypoint__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence__fini(etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mcm_uulm_msgs__msg__Waypoint__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence *
etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence * array = (etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence__destroy(etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence__are_equal(const etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence * lhs, const etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__Waypoint__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence__copy(
  const etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence * input,
  etsi_its_mcm_uulm_msgs__msg__Waypoint__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mcm_uulm_msgs__msg__Waypoint);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mcm_uulm_msgs__msg__Waypoint * data =
      (etsi_its_mcm_uulm_msgs__msg__Waypoint *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mcm_uulm_msgs__msg__Waypoint__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mcm_uulm_msgs__msg__Waypoint__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__Waypoint__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
