// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/Waypoint.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__WAYPOINT__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__WAYPOINT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'x_distance'
// Member 'y_distance'
#include "etsi_its_mcm_uulm_msgs/msg/detail/cartesian_coordinate_large__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__Waypoint __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__Waypoint __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Waypoint_
{
  using Type = Waypoint_<ContainerAllocator>;

  explicit Waypoint_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : x_distance(_init),
    y_distance(_init)
  {
    (void)_init;
  }

  explicit Waypoint_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : x_distance(_alloc, _init),
    y_distance(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _x_distance_type =
    etsi_its_mcm_uulm_msgs::msg::CartesianCoordinateLarge_<ContainerAllocator>;
  _x_distance_type x_distance;
  using _y_distance_type =
    etsi_its_mcm_uulm_msgs::msg::CartesianCoordinateLarge_<ContainerAllocator>;
  _y_distance_type y_distance;

  // setters for named parameter idiom
  Type & set__x_distance(
    const etsi_its_mcm_uulm_msgs::msg::CartesianCoordinateLarge_<ContainerAllocator> & _arg)
  {
    this->x_distance = _arg;
    return *this;
  }
  Type & set__y_distance(
    const etsi_its_mcm_uulm_msgs::msg::CartesianCoordinateLarge_<ContainerAllocator> & _arg)
  {
    this->y_distance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__Waypoint
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__Waypoint
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::Waypoint_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Waypoint_ & other) const
  {
    if (this->x_distance != other.x_distance) {
      return false;
    }
    if (this->y_distance != other.y_distance) {
      return false;
    }
    return true;
  }
  bool operator!=(const Waypoint_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Waypoint_

// alias to use template instance with default allocator
using Waypoint =
  etsi_its_mcm_uulm_msgs::msg::Waypoint_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__WAYPOINT__STRUCT_HPP_
