// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mcm_uulm_msgs:msg/LongitudinalWaypoint.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__STRUCT_H_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'waypoint'
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint__struct.h"
// Member 'min_arrival_time'
// Member 'max_arrival_time'
// Member 'min_duration_of_stop'
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint_delta_time__struct.h"
// Member 'min_velocity'
// Member 'max_velocity'
#include "etsi_its_mcm_uulm_msgs/msg/detail/speed_value__struct.h"
// Member 'preceding_road_user'
// Member 'following_road_user'
#include "etsi_its_mcm_uulm_msgs/msg/detail/participating_road_user_index__struct.h"
// Member 'yield_to_road_user_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/yield_to_road_user_container__struct.h"

/// Struct defined in msg/LongitudinalWaypoint in the package etsi_its_mcm_uulm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
  ///   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
  ///   -t
  ///   mcm_uulm
  ///   -o
  ///   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LongitudinalWaypoint ::= SEQUENCE {
  ///  waypoint                    Waypoint,
  ///  minArrivalTime              WaypointDeltaTime,
  ///  maxArrivalTime              WaypointDeltaTime,
  ///  minVelocity                 SpeedValue          OPTIONAL,
  ///  maxVelocity                 SpeedValue          OPTIONAL,
  ///  minDurationOfStop           WaypointDeltaTime           OPTIONAL,
  ///  precedingRoadUser           ParticipatingRoadUserIndex  OPTIONAL,
  ///  followingRoadUser           ParticipatingRoadUserIndex  OPTIONAL,
  ///  yieldToRoadUserContainer    YieldToRoadUserContainer    OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_mcm_uulm_msgs__msg__Waypoint waypoint;
  etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime min_arrival_time;
  etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime max_arrival_time;
  etsi_its_mcm_uulm_msgs__msg__SpeedValue min_velocity;
  bool min_velocity_is_present;
  etsi_its_mcm_uulm_msgs__msg__SpeedValue max_velocity;
  bool max_velocity_is_present;
  etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime min_duration_of_stop;
  bool min_duration_of_stop_is_present;
  etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex preceding_road_user;
  bool preceding_road_user_is_present;
  etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex following_road_user;
  bool following_road_user_is_present;
  etsi_its_mcm_uulm_msgs__msg__YieldToRoadUserContainer yield_to_road_user_container;
  bool yield_to_road_user_container_is_present;
} etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint;

// Struct for a sequence of etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint.
typedef struct etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence
{
  etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__STRUCT_H_
