// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mcm_uulm_msgs:msg/ManeuverConstraints.idl
// generated code does not contain a copyright notice
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_constraints__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `maneuver_type`
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_type__functions.h"
// Member `longitudinal_maneuver_waypoint_container`
#include "etsi_its_mcm_uulm_msgs/msg/detail/longitudinal_maneuver_waypoint_container__functions.h"
// Member `maneuver_corridor`
#include "etsi_its_mcm_uulm_msgs/msg/detail/polygon__functions.h"

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__init(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * msg)
{
  if (!msg) {
    return false;
  }
  // maneuver_type
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverType__init(&msg->maneuver_type)) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(msg);
    return false;
  }
  // maneuver_type_is_present
  // longitudinal_maneuver_waypoint_container
  if (!etsi_its_mcm_uulm_msgs__msg__LongitudinalManeuverWaypointContainer__init(&msg->longitudinal_maneuver_waypoint_container)) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(msg);
    return false;
  }
  // maneuver_corridor
  if (!etsi_its_mcm_uulm_msgs__msg__Polygon__init(&msg->maneuver_corridor)) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(msg);
    return false;
  }
  // maneuver_corridor_is_present
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * msg)
{
  if (!msg) {
    return;
  }
  // maneuver_type
  etsi_its_mcm_uulm_msgs__msg__ManeuverType__fini(&msg->maneuver_type);
  // maneuver_type_is_present
  // longitudinal_maneuver_waypoint_container
  etsi_its_mcm_uulm_msgs__msg__LongitudinalManeuverWaypointContainer__fini(&msg->longitudinal_maneuver_waypoint_container);
  // maneuver_corridor
  etsi_its_mcm_uulm_msgs__msg__Polygon__fini(&msg->maneuver_corridor);
  // maneuver_corridor_is_present
}

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__are_equal(const etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * lhs, const etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // maneuver_type
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverType__are_equal(
      &(lhs->maneuver_type), &(rhs->maneuver_type)))
  {
    return false;
  }
  // maneuver_type_is_present
  if (lhs->maneuver_type_is_present != rhs->maneuver_type_is_present) {
    return false;
  }
  // longitudinal_maneuver_waypoint_container
  if (!etsi_its_mcm_uulm_msgs__msg__LongitudinalManeuverWaypointContainer__are_equal(
      &(lhs->longitudinal_maneuver_waypoint_container), &(rhs->longitudinal_maneuver_waypoint_container)))
  {
    return false;
  }
  // maneuver_corridor
  if (!etsi_its_mcm_uulm_msgs__msg__Polygon__are_equal(
      &(lhs->maneuver_corridor), &(rhs->maneuver_corridor)))
  {
    return false;
  }
  // maneuver_corridor_is_present
  if (lhs->maneuver_corridor_is_present != rhs->maneuver_corridor_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__copy(
  const etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * input,
  etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * output)
{
  if (!input || !output) {
    return false;
  }
  // maneuver_type
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverType__copy(
      &(input->maneuver_type), &(output->maneuver_type)))
  {
    return false;
  }
  // maneuver_type_is_present
  output->maneuver_type_is_present = input->maneuver_type_is_present;
  // longitudinal_maneuver_waypoint_container
  if (!etsi_its_mcm_uulm_msgs__msg__LongitudinalManeuverWaypointContainer__copy(
      &(input->longitudinal_maneuver_waypoint_container), &(output->longitudinal_maneuver_waypoint_container)))
  {
    return false;
  }
  // maneuver_corridor
  if (!etsi_its_mcm_uulm_msgs__msg__Polygon__copy(
      &(input->maneuver_corridor), &(output->maneuver_corridor)))
  {
    return false;
  }
  // maneuver_corridor_is_present
  output->maneuver_corridor_is_present = input->maneuver_corridor_is_present;
  return true;
}

etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints *
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * msg = (etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints));
  bool success = etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__destroy(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence__init(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * data = NULL;

  if (size) {
    data = (etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints *)allocator.zero_allocate(size, sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence__fini(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence *
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence * array = (etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence__destroy(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence__are_equal(const etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence * lhs, const etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence__copy(
  const etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence * input,
  etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints * data =
      (etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
