// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/ManeuverContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'road_user_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_container__traits.hpp"
// Member 'suggested_maneuver_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/suggested_maneuver_container__traits.hpp"

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ManeuverContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: road_user_container
  {
    out << "road_user_container: ";
    to_flow_style_yaml(msg.road_user_container, out);
    out << ", ";
  }

  // member: suggested_maneuver_container
  {
    out << "suggested_maneuver_container: ";
    to_flow_style_yaml(msg.suggested_maneuver_container, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ManeuverContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: road_user_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_user_container:\n";
    to_block_style_yaml(msg.road_user_container, out, indentation + 2);
  }

  // member: suggested_maneuver_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "suggested_maneuver_container:\n";
    to_block_style_yaml(msg.suggested_maneuver_container, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ManeuverContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mcm_uulm_msgs::msg::ManeuverContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mcm_uulm_msgs::msg::ManeuverContainer & msg)
{
  return etsi_its_mcm_uulm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer>()
{
  return "etsi_its_mcm_uulm_msgs::msg::ManeuverContainer";
}

template<>
inline const char * name<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer>()
{
  return "etsi_its_mcm_uulm_msgs/msg/ManeuverContainer";
}

template<>
struct has_fixed_size<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer>::value> {};

template<>
struct has_bounded_size<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer>::value> {};

template<>
struct is_message<etsi_its_mcm_uulm_msgs::msg::ManeuverContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONTAINER__TRAITS_HPP_
