// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/ManeuverParameters.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_PARAMETERS__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_PARAMETERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'maneuver_constraints'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_constraints__struct.hpp"
// Member 'termination_status'
#include "etsi_its_mcm_uulm_msgs/msg/detail/termination_status__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverParameters __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverParameters __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ManeuverParameters_
{
  using Type = ManeuverParameters_<ContainerAllocator>;

  explicit ManeuverParameters_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : maneuver_constraints(_init),
    termination_status(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit ManeuverParameters_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : maneuver_constraints(_alloc, _init),
    termination_status(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _maneuver_constraints_type =
    etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator>;
  _maneuver_constraints_type maneuver_constraints;
  using _termination_status_type =
    etsi_its_mcm_uulm_msgs::msg::TerminationStatus_<ContainerAllocator>;
  _termination_status_type termination_status;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__maneuver_constraints(
    const etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints_<ContainerAllocator> & _arg)
  {
    this->maneuver_constraints = _arg;
    return *this;
  }
  Type & set__termination_status(
    const etsi_its_mcm_uulm_msgs::msg::TerminationStatus_<ContainerAllocator> & _arg)
  {
    this->termination_status = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_MANEUVER_CONSTRAINTS =
    0u;
  static constexpr uint8_t CHOICE_TERMINATION_STATUS =
    1u;

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverParameters
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverParameters
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ManeuverParameters_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->maneuver_constraints != other.maneuver_constraints) {
      return false;
    }
    if (this->termination_status != other.termination_status) {
      return false;
    }
    return true;
  }
  bool operator!=(const ManeuverParameters_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ManeuverParameters_

// alias to use template instance with default allocator
using ManeuverParameters =
  etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ManeuverParameters_<ContainerAllocator>::CHOICE_MANEUVER_CONSTRAINTS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ManeuverParameters_<ContainerAllocator>::CHOICE_TERMINATION_STATUS;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_PARAMETERS__STRUCT_HPP_
