// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/SuggestedManeuverContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'target_station_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/station_id__struct.hpp"
// Member 'suggested_maneuver'
#include "etsi_its_mcm_uulm_msgs/msg/detail/suggested_maneuver__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SuggestedManeuverContainer_
{
  using Type = SuggestedManeuverContainer_<ContainerAllocator>;

  explicit SuggestedManeuverContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : target_station_id(_init),
    suggested_maneuver(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->suggested_maneuver_is_present = false;
    }
  }

  explicit SuggestedManeuverContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : target_station_id(_alloc, _init),
    suggested_maneuver(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->suggested_maneuver_is_present = false;
    }
  }

  // field types and members
  using _target_station_id_type =
    etsi_its_mcm_uulm_msgs::msg::StationId_<ContainerAllocator>;
  _target_station_id_type target_station_id;
  using _suggested_maneuver_type =
    etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator>;
  _suggested_maneuver_type suggested_maneuver;
  using _suggested_maneuver_is_present_type =
    bool;
  _suggested_maneuver_is_present_type suggested_maneuver_is_present;

  // setters for named parameter idiom
  Type & set__target_station_id(
    const etsi_its_mcm_uulm_msgs::msg::StationId_<ContainerAllocator> & _arg)
  {
    this->target_station_id = _arg;
    return *this;
  }
  Type & set__suggested_maneuver(
    const etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator> & _arg)
  {
    this->suggested_maneuver = _arg;
    return *this;
  }
  Type & set__suggested_maneuver_is_present(
    const bool & _arg)
  {
    this->suggested_maneuver_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SuggestedManeuverContainer_ & other) const
  {
    if (this->target_station_id != other.target_station_id) {
      return false;
    }
    if (this->suggested_maneuver != other.suggested_maneuver) {
      return false;
    }
    if (this->suggested_maneuver_is_present != other.suggested_maneuver_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const SuggestedManeuverContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SuggestedManeuverContainer_

// alias to use template instance with default allocator
using SuggestedManeuverContainer =
  etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER_CONTAINER__STRUCT_HPP_
